from typing import List
import jieba
import re
import unicodedata

class CHNTokenizer:
    def __init__(self):
        pass

    def normalize_text(self, text):
        # 大小写归一化
        text = text.lower()

        # 全角转半角
        normalized_text = ""
        for char in text:
            code = ord(char)
            if 0xFF01 <= code <= 0xFF5E:
                code -= 0xFEE0
                char = chr(code)
            normalized_text += unicodedata.normalize('NFKC', char)

        return normalized_text

    def __call__(self, text):
        if not isinstance(text, str):
            raise ValueError("Tokenizer only support string")
        tokens = list(jieba.cut(text))
        tokens = [self.normalize_text(token) for token in tokens if re.match(r'\w', token)]
        return tokens
