from bm25_encoder import BM25Encoder


def prepare_documents():
    with open('./data/example.data', 'r') as f:
        lines = f.readlines()
        print(lines[0])
        documents = [line.strip() for line in lines]
        return documents

def main():
    # 准备全量数据
    texts = prepare_documents()
    print(texts[0])

    # 使用bm25生成稀疏向量
    bm25 = BM25Encoder()
    # 先fit得到计算bm25必需的平均文档长度等统计信息
    bm25.fit(texts)

    # 得到doc的稀疏向量
    document_sparse_vectors = bm25.encode_documents(texts)

    # 得到query的稀疏向量
    queries = ["冰糖雪梨", "尼康微单照相机"]
    query_sparse_vectors = bm25.encode_queries(queries)
    print("Query Sparse Vectors: ", query_sparse_vectors)


if __name__ == "__main__":
    main()
