from bgeM3_encoder import BGEM3Encoder


def prepare_documents():
    with open('./data/example.data', 'r') as f:
        lines = f.readlines()
        print(lines[0])
        documents = [line.strip() for line in lines]
        return documents

def main():
    # 准备全量数据
    texts = prepare_documents()
    print(texts[0])

    # 使用bge-m3模型生成稀疏向量
    bgeM3 = BGEM3Encoder()

    # 得到doc的稀疏向量
    document_sparse_vectors = bgeM3.encode(texts)

    # 得到query的稀疏向量
    queries = ["冰糖雪梨", "尼康微单照相机"]
    query_sparse_vectors = bgeM3.encode(queries)
    print("Query Sparse Vectors: ", query_sparse_vectors)


if __name__ == "__main__":
    main()
